--[[
function NewRaycastWeaponBase:replenish()
	local ammo_max_multiplier = managers.player:upgrade_value("player", "extra_ammo_multiplier", 1)
	ammo_max_multiplier = ammo_max_multiplier * managers.player:upgrade_value(self:weapon_tweak_data().category, "extra_ammo_multiplier", 1)
	ammo_max_multiplier = ammo_max_multiplier + ammo_max_multiplier * (self._total_ammo_mod or 0)
	if managers.player:has_category_upgrade("player", "add_armor_stat_skill_ammo_mul") then
		ammo_max_multiplier = ammo_max_multiplier * managers.player:body_armor_value("skill_ammo_mul", nil, 1)
	end
    if managers.player:has_category_upgrade("player", "ammo_penalty_multiplier") then
        ammo_max_multiplier = ammo_max_multiplier * managers.player:upgrade_value("player", "ammo_penalty_multiplier")
        --log("Reducing ammo by ".. managers.player:upgrade_value("player", "ammo_penalty_multiplier").."x")
    end
	local ammo_max_per_clip = self:calculate_ammo_max_per_clip()
	local ammo_max = math.round((tweak_data.weapon[self._name_id].AMMO_MAX + managers.player:upgrade_value(self._name_id, "clip_amount_increase") * ammo_max_per_clip) * ammo_max_multiplier)
	ammo_max_per_clip = math.min(ammo_max_per_clip, ammo_max)
	self:set_ammo_max_per_clip(ammo_max_per_clip)
	self:set_ammo_max(ammo_max)
	self:set_ammo_total(ammo_max)
	self:set_ammo_remaining_in_clip(ammo_max_per_clip)
    self._ammo_pickup = tweak_data.weapon[self._name_id].AMMO_PICKUP 
	self:update_damage()
end
]]

Hooks:PostHook(NewRaycastWeaponBase, "set_ammo_max", "SociopathRework_SetMaxAmmoNew", function(self, ammo_max)

    if managers.player:has_category_upgrade("player", "ammo_penalty_multiplier") then
        ammo_max = ammo_max * managers.player:upgrade_value("player", "ammo_penalty_multiplier")
        self._ammo_max2 = self:digest_value(ammo_max, true)
        self._ammo_max = nil
    else
        log("Ammo penalty is not active.")
    end

end)

Hooks:PostHook(NewRaycastWeaponBase, "set_ammo_total", "SociopathRework_SetTotalAmmoNew", function(self, ammo_total)

    if managers.player:has_category_upgrade("player", "ammo_penalty_multiplier") then
        ammo_total = ammo_total * managers.player:upgrade_value("player", "ammo_penalty_multiplier")
        self._ammo_total = self:digest_value(ammo_total, true)
    else
        log("Ammo penalty is not active.")
    end

end)

local newraycastweaponbase_add_ammo_orig = NewRaycastWeaponBase.add_ammo
function NewRaycastWeaponBase:add_ammo(ratio, add_amount_override)
    
    ratio = ratio or 1
    if managers.player:has_category_upgrade("player", "ammo_pickup_multiplier") then
        ratio = ratio * managers.player:upgrade_value("player", "ammo_pickup_multiplier")
    end
    
    return newraycastweaponbase_add_ammo_orig(self, ratio, add_amount_override)
    
end