--Give sociopath melee kill movement speed
Hooks:PostHook(PlayerManager, "on_killshot", "SociopathReworkPlayerManagerKill", function(self, killed_unit, variant)

    if variant == "melee" and self:has_category_upgrade("temporary", "melee_kill_movement_speed") then
        self:activate_temporary_upgrade("temporary", "melee_kill_movement_speed")
    end

end)

--Check sociopath melee kill movement speed
local player_movementspeed_multiplier_orig = PlayerManager.movement_speed_multiplier
function PlayerManager:movement_speed_multiplier(speed_state, bonus_multiplier, upgrade_level, health_ratio)
    
    local multiplier = player_movementspeed_multiplier_orig(self, speed_state, bonus_multiplier, upgrade_level, health_ratio)
    
    multiplier = multiplier * self:temporary_upgrade_value("temporary", "melee_kill_movement_speed", 1)
    
	return multiplier
end

--Sociopath health penalty
local playermanager_health_mul_orig = PlayerManager.health_skill_multiplier
function PlayerManager:health_skill_multiplier()
    
    local multiplier = playermanager_health_mul_orig(self)
    
    if self:has_category_upgrade("player", "passive_health_multiplier_penalty") then
        multiplier = multiplier * self:upgrade_value("player", "passive_health_multiplier_penalty")
    end
    
    return multiplier
    
end

--Sociopath armor penalty
local playermanager_armor_mul_orig = PlayerManager.body_armor_skill_multiplier
function PlayerManager:body_armor_skill_multiplier(override_armor)
	local multiplier = playermanager_armor_mul_orig(self, override_armor)
    
    if self:has_category_upgrade("player", "passive_armor_multiplier_penalty") then
        multiplier = multiplier * self:upgrade_value("player", "passive_armor_multiplier_penalty")
    end  
    
	return multiplier
end

--Sociopath dodge chance
local playermanager_dodge_chance_orig = PlayerManager.skill_dodge_chance
function PlayerManager:skill_dodge_chance(running, crouching, on_zipline, override_armor, detection_risk)
    
    local chance = playermanager_dodge_chance_orig(self, running, crouching, on_zipline, override_armor, detection_risk)
    
    if self:has_category_upgrade("player", "passive_sociopath_dodge_chance") then
        chance = chance + self:upgrade_value("player", "passive_sociopath_dodge_chance")
    end
    
    return chance
    
end